org.apache.tinkerpop.gremlin.process.traversal.step.filter

## Class DedupGlobalStep<S>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,S>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.filter.FilterStep<S>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.filter.DedupGlobalStep<S>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<S>>, Step<S,S>, Barrier<Map<Object,Traverser.Admin<S>>>, ByModulating, GraphComputing, MemoryComputing<Map<Object,Traverser.Admin<S>>>, PathProcessor, Scoping, TraversalParent

      public final class DedupGlobalStep<S>
      extends FilterStep<S>
      implements TraversalParent, Scoping, GraphComputing, Barrier<Map<Object,Traverser.Admin<S>>>, ByModulating, PathProcessor

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `Scoping.KeyNotFoundException, Scoping.Variable`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `PathProcessor.ElementRequirement`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DedupGlobalStep(Traversal.Admin traversal, String... dedupLabels)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addBarrier(Map<Object,Traverser.Admin<S>> barrier)` Add a barrier to the step.
    `void` | `atMaster(boolean atMaster)` Some steps should behave different whether they are executing at the master traversal or distributed across the worker traversals.
    `DedupGlobalStep<S>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `protected boolean` | `filter(Traverser.Admin<S> traverser)`
    `Set<String>` | `getKeepLabels()`
    `List<Traversal<S,Object>>` | `getLocalChildren()`
    `PathProcessor.ElementRequirement` | `getMaxRequirement()`
    `MemoryComputeKey<Map<Object,Traverser.Admin<S>>>` | `getMemoryComputeKey()` The `MemoryComputeKey` that will be used by this step.
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `Set<String>` | `getScopeKeys()` Get the labels that this scoping step will access during the traversal
    `int` | `hashCode()`
    `boolean` | `hasNextBarrier()` Whether or not the step has an accessible barrier.
    `void` | `modulateBy(Traversal.Admin<?,?> dedupTraversal)`
    `Map<Object,Traverser.Admin<S>>` | `nextBarrier()` Get the next barrier within this step.
    `void` | `onGraphComputer()` The step will be executing on a `GraphComputer`.
    `void` | `processAllStarts()` Process all left traversers by do not yield the resultant output.
    `protected Traverser.Admin<S>` | `processNextStart()`
    `void` | `replaceLocalChild(Traversal.Admin<?,?> oldTraversal, Traversal.Admin<?,?> newTraversal)`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setKeepLabels(Set<String> keepLabels)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `getNullableScopeValue, getSafeScopeValue, getScopeValue`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.GraphComputing

      `atMaster`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Barrier

      `done`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `processTraverserPathLabels`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### DedupGlobalStep

          public DedupGlobalStep(Traversal.Admin traversal,
                                 String... dedupLabels)

  - ### Method Detail

    - #### filter

          protected boolean filter(Traverser.Admin<S> traverser)

      Specified by:
        `filter` in class `FilterStep<S>`

    - #### atMaster

          public void atMaster(boolean atMaster)

      Description copied from interface: `GraphComputing`
      Some steps should behave different whether they are executing at the master traversal or distributed across the worker traversals. The default implementation does nothing.
      Specified by:
        `atMaster` in interface `GraphComputing`
      Parameters:
        `atMaster` - whether the step is currently executing at master

    - #### getMaxRequirement

          public PathProcessor.ElementRequirement getMaxRequirement()

      Specified by:
        `getMaxRequirement` in interface `PathProcessor`

    - #### processNextStart

          protected Traverser.Admin<S> processNextStart()

      Overrides:
        `processNextStart` in class `FilterStep<S>`

    - #### getLocalChildren

          public List<Traversal<S,Object>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> dedupTraversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### replaceLocalChild

          public void replaceLocalChild(Traversal.Admin<?,?> oldTraversal,
                                        Traversal.Admin<?,?> newTraversal)

      Specified by:
        `replaceLocalChild` in interface `TraversalParent`

    - #### clone

          public DedupGlobalStep<S> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,S>`
      Overrides:
        `clone` in class `AbstractStep<S,S>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,S>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,S>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,S>`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,S>`
      Overrides:
        `reset` in class `AbstractStep<S,S>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,S>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,S>`
      Returns:
        the set of requirements

    - #### onGraphComputer

          public void onGraphComputer()

      Description copied from interface: `GraphComputing`
      The step will be executing on a `GraphComputer`.
      Specified by:
        `onGraphComputer` in interface `GraphComputing`

    - #### getScopeKeys

          public Set<String> getScopeKeys()

      Description copied from interface: `Scoping`
      Get the labels that this scoping step will access during the traversal
      Specified by:
        `getScopeKeys` in interface `Scoping`
      Returns:
        the accessed labels of the scoping step

    - #### processAllStarts

          public void processAllStarts()

      Description copied from interface: `Barrier`
      Process all left traversers by do not yield the resultant output. This method is useful for steps like `ReducingBarrierStep`, where traversers can be processed "on the fly" and thus, reduce memory consumption.
      Specified by:
        `processAllStarts` in interface `Barrier<Map<Object,Traverser.Admin<S>>>`

    - #### hasNextBarrier

          public boolean hasNextBarrier()

      Description copied from interface: `Barrier`
      Whether or not the step has an accessible barrier.
      Specified by:
        `hasNextBarrier` in interface `Barrier<Map<Object,Traverser.Admin<S>>>`
      Returns:
        whether a barrier exists or not

    - #### nextBarrier

          public Map<Object,Traverser.Admin<S>> nextBarrier()
                                                     throws NoSuchElementException

      Description copied from interface: `Barrier`
      Get the next barrier within this step. Barriers from parallel steps can be the be merged to create a single step with merge barriers.
      Specified by:
        `nextBarrier` in interface `Barrier<Map<Object,Traverser.Admin<S>>>`
      Returns:
        the next barrier of the step
      Throws:
        `NoSuchElementException`

    - #### addBarrier

          public void addBarrier(Map<Object,Traverser.Admin<S>> barrier)

      Description copied from interface: `Barrier`
      Add a barrier to the step. This typically happens when multiple parallel barriers need to become one barrier at a single step.
      Specified by:
        `addBarrier` in interface `Barrier<Map<Object,Traverser.Admin<S>>>`
      Parameters:
        `barrier` - the barrier to merge in

    - #### getMemoryComputeKey

          public MemoryComputeKey<Map<Object,Traverser.Admin<S>>> getMemoryComputeKey()

      Description copied from interface: `MemoryComputing`
      The `MemoryComputeKey` that will be used by this step.
      Specified by:
        `getMemoryComputeKey` in interface `MemoryComputing<Map<Object,Traverser.Admin<S>>>`
      Returns:
        the MemoryComputeKey to use

    - #### setKeepLabels

          public void setKeepLabels(Set<String> keepLabels)

      Specified by:
        `setKeepLabels` in interface `PathProcessor`

    - #### getKeepLabels

          public Set<String> getKeepLabels()

      Specified by:
        `getKeepLabels` in interface `PathProcessor`

Copyright © 2013–2021 Apache Software Foundation. All rights reserved.